﻿#include "MainWindow.h"
#include "resource.h"
#include "Utils/Utils.h"
MainWindow::MainWindow()
{
	this->label1 = new Label(this);
	this->tInput = new TextBox(this);
	this->bOK = new Button(this);
	this->pb = new ProgressBar(this);
	this->MaxBox = FALSE;

	// Window
	this->Size = SIZE{ 300, 120 };
	this->Text = L"KCE";
	this->CanResize = FALSE;
	this->Icon = LoadIcon(GetModuleHandle(NULL), MAKEINTRESOURCE(IDI_ICON1));

	this->label1->SetRect(10, 10, 200, 20);
	this->label1->Text = L"URL";

	this->tInput->SetRect(10, 32, 200, 24);

	this->bOK->SetRect(215, 32, 60, 24);
	this->bOK->Text = L"开始";
	this->bOK->OnClicked += GUI_EVENT_LINK(this->bOK_OnClick);

	this->pb->SetRect(10, 60, 200, 10);

}
MainWindow::~MainWindow() {}

typedef struct Chapter
{
	std::string url;
	std::string title;
};
std::vector<Chapter> GetAllChapter(std::string url, std::string& bookName)
{
	std::vector<Chapter> res;
	auto html = HttpHelper::HttpRequestGet(url);
	while (0x00088b1f == *(UINT32*)html.c_str())
	{
		html = HttpHelper::HttpRequestGet(url);
		printf(".");
	}
	html = Convert::Utf8ToAnsi(html);
	auto nameStart = html.find(R"(<h1>)");
	auto nameEnd = html.find(R"(</h1>)");
	if (nameStart != std::string::npos && nameEnd != std::string::npos)
	{
		size_t nameLen = (nameEnd - nameStart) - 4;
		std::string bkName = html.substr(nameStart + 4, nameLen);
		bookName = bkName;
	}

	auto lines = StringHelper::Split(html, { '\r','\n' });
	for (auto l : lines)
	{
		auto found = l.find(R"(<li><a style="" href=")");
		if (found != std::string::npos)
		{
			auto start = found + 22;
			auto end = l.find(".html") + 5;
			auto u = l.substr(start, end - start);
			if (u.size() > 5)
			{
				auto title = l.substr(end + 2);
				title = title.substr(0, title.size() - 9);
				Chapter c;
				if (url.ends_with("/"))
					c.url = url + u;
				else
					c.url = url + "/" + u;
				c.title = title;
				res.push_back(c);

			}
		}
	}
	return res;
}
std::string GetBook(std::string url)
{
	auto html = HttpHelper::HttpRequestGet(url);
	while (0x88b1f == *(UINT32*)html.c_str())
	{
		html = HttpHelper::HttpRequestGet(url);
		printf(".");
	}
	html = Convert::Utf8ToAnsi(html);
	std::stringstream sb;
	auto lines = StringHelper::Split(html, { '\r','\n' });
	for (auto l : lines)
	{
		auto found = l.find(R"(&nbsp;&nbsp;&nbsp;&nbsp;)");
		if (found != std::string::npos)
		{
			auto ls = StringHelper::Replace(l, "&nbsp;&nbsp;&nbsp;&nbsp;", "");
			ls = StringHelper::Replace(ls, "<br /><br />", "\n");
			ls = StringHelper::Replace(ls, "</div>", "\n");
			return ls;
		}
	}
	return "";
}
bool MainWindow::DownloadBook(std::string bookPage, std::string savePath)
{
	std::string bookName = "";
	auto pages = GetAllChapter(bookPage, bookName);
	if (bookName.size() == 0)
		return false;
	savePath.append(bookName);
	savePath.append(".txt");
	File::Delete(savePath);
	File::Create(savePath);
	int index = 0;
	for (auto u : pages)
	{
		int errc = 0;
	retry:
		std::string bk = GetBook(u.url);
		if (bk.size() == 0)
		{
			printf("[-] %d/%d %s -> ERROR\n", index + 1, pages.size(), u.url.c_str());
			if (errc++ > 10)
				return false;
			goto retry;
		}
		else
		{
			printf("[+] %d/%d %s -> OK\n", index + 1, pages.size(), u.url.c_str());
			File::AppendAllText(savePath, u.title + "\n");
			File::AppendAllText(savePath, bk);
		}
		index += 1;
		this->pb->MaxValue = pages.size();
		this->pb->Value = index;
	}
	return true;
}
void MainWindow::bOK_OnClick(Control* sender, HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	std::string url = Convert::wstring_to_string(this->tInput->Text);
	this->tInput->Text = L"";
	auto run = [&]() {return this->DownloadBook(Convert::AnsiToUtf8(url), ""); };
	Task tsk(run);
	auto runner = tsk.Start();
	this->bOK->Enable = false;
	while (true)
	{
		Sleep(1);
		Window::DoEvent();
		if (runner.IsComplete())
			break;
	}
	if (runner.Get())
		MessageBoxW(this->m_Handle, L"下载完成", L"提示", MB_OK);
	else
		MessageBoxW(this->m_Handle, L"下载失败", L"提示", MB_OK);
	this->bOK->Enable = true;
	this->pb->Value = 0;
	UpdateWindow(this->m_Handle);
}